local ContractBoxGui_create_character_text = ContractBoxGui.create_character_text
function ContractBoxGui:create_character_text(peer_id, x, y, ...)
	ContractBoxGui_create_character_text(self, peer_id, x, y, ...)
	
	local local_peer = managers.network:session() and managers.network:session():local_peer()
	if local_peer and peer_id ~= local_peer:id() then
		local color = tweak_data.chat_colors[peer_id] or tweak_data.chat_colors[#tweak_data.chat_colors]
		self._ping_text = self._ping_text or {}
		self._ping_text[peer_id] = self._ping_text[peer_id] or self._panel:text({
			vertical = "top",
			name = "lobby_player_latency",
			blend_mode = "add",
			align = "center",
			text = "",
			layer = 0,
			font_size = tweak_data.menu.pd2_medium_font_size - 3,
			font = tweak_data.menu.pd2_medium_font,
			color = color
		})
		
		local _, _, w, h = self._peers[peer_id]:text_rect()
		self._ping_text[peer_id]:set_size(w, h)
		self._ping_text[peer_id]:set_center(x, y-25)
	end
end

local ContractBoxGui_update_character = ContractBoxGui.update_character
function ContractBoxGui:update_character(peer_id)
	ContractBoxGui_update_character(self, peer_id)
	
	if not self._ping_text or not self._ping_text[peer_id] then
		return
	end
	
	local peer = managers.network:session():peer(peer_id)
	
	if peer then
		local msPing = math.floor(peer:qos().ping) .. "ms"
		self._ping_text[peer_id]:set_text(msPing)
	end
end